using System.Collections.Generic;
using System.Threading.Tasks;
using GxPress.Result.DataCenter;
using GxPress.Service.Interface.PlatformData;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;

namespace GxPress.Api.AdminControllers
{
    /// <summary>
    /// 平台数据
    /// </summary>
    [Route("api/admin/platform")]
    [ApiController]
    [Authorize]
    public class AdminPlatformDataController : Controller
    {
        private readonly IPlatformDataService platformDataService;
        public AdminPlatformDataController(IPlatformDataService platformDataService)
        {
            this.platformDataService = platformDataService;
        }
        /// <summary>
        /// 平台数据
        /// </summary>
        /// <returns></returns>
        [HttpGet("data")]
        public async Task<PlatformDataResult> GetPlatformDataResult()
        {
            var result = new PlatformDataResult();
            result.PlatformOperationDataResult = await platformDataService.GetPlatformDataAsync();
            result.UserIncreaseResult = new UserIncreaseResult();
            result.UserAreaDistributingResults = new List<UserAreaDistributingResult>();
            result.UserVipProportionResult = new UserVipProportionResult();
            result.OnlineUserResult = new OnlineUserResult();
            result.PlatformContentDataResult = new PlatformContentDataResult();
            result.ContentTypeDistributingResult = new List<ContentTypeDistributingResult>();
            result.ContentOlogyDistributingResult = new List<ContentOlogyDistributingResult>();
            result.PayContentstatisticsResult = new PayContentstatisticsResult();
            result.ContentIncreaseResult = new ContentIncreaseResult();
            result.PlatformAccumulativeVisitResult = new PlatformAccumulativeVisitResult();
            result.VisitPortResult = new List<VisitPortResult>();
            result.PlatformCommerceResult = new PlatformCommerceResult();
            result.ContentSaleRankingResults = new List<ContentSaleRankingResult>();
            result.ContentSaleProportionResults = new List<ContentSaleProportionResult>();
            return result;
        }
    }
}